/*------------------------------------------------------------
 * Layout common classes and setup
 *------------------------------------------------------------*/

.clearfix {
	&:before,
	&:after {
		display: table;
		content: "";
	}
	&:after {
		clear: both;
	}
}

*,*:before,*:after {
	-webkit-box-sizing: border-box;
	   -moz-box-sizing: border-box;
	        box-sizing: border-box;
}



/*------------------------------------------------------------
 * Main Layout
 *------------------------------------------------------------*/

/* Layout: Basics - Mobile & TabletV + Defaults
 *------------------------------------------------------------*/

body.hygge-lightbox--true {
	// TODO: Play with disabling scroll but keeping scrollbars
}

.hygge-layout-wrapper {
	@media @tablet-h, @desktop {
		display: flex;
		align-items: stretch;
	}
}

.hygge-layout-main {
	overflow: hidden;
	flex-grow: 1;
	flex-shrink: 1;
}

.hygge-layout-sidebar {
	overflow: hidden;
	flex-grow: 0;
	flex-shrink: 0;
	.transition( ~"all 0.5s cubic-bezier(0.7, 0, 0.3, 1)" );
	flex-basis: @sidebar_width;
	padding-left: 30px;
	padding-right: 30px;

	.hygge-sidebar--false & {
		padding-left: 0;
		padding-right: 0;
		flex-basis: 0;
		.translateX(100%);
	}

	.sidebar__content {
		padding-top: 60px;
		padding-bottom: 90px;

		@media @tablet-h, @desktop {
			width: calc(~"@{sidebar_width} - 60px");
		}
	}
}

.content-wrapper {
	position: relative;
	z-index: 1;
}

.main-content {
	.max-width-wrapper;
}



/* Layout: Basics - TabletH & Desktop
 * Sidebar is position beside the main content
 *------------------------------------------------------------*/

@media @tablet-h, @desktop {
	.content-wrapper {
	}
} // /media query




/*------------------------------------------------------------
 * Max Width Wrapper
 *------------------------------------------------------------*/

.padding-wrapper {
	margin-left: auto;
	margin-right: auto;
	padding-left: 20px;
	padding-right: 20px;

	@media @tablet {
		padding-left: 50px;
		padding-right: 50px;
	}

	@media @desktop {
		padding-left: 60px;
		padding-right: 60px;
	}

	@media @desktop-m {
		padding-left: 80px;
		padding-right: 80px;
	}
}

.max-width-wrapper {
	.padding-wrapper;
	max-width: 1360px;
}





/*------------------------------------------------------------
 * Post Content
 *------------------------------------------------------------*/

.post__content,
.post__comments__inwrap {
	@media @desktop-s {
		padding-left: ~"calc( @{sideblock_width_small} + 60px )";
	}

	@media @desktop-m {
		padding-left: ~"calc( @{sideblock_width} + 60px )";
	}

	@media @desktop-l {
		padding-left: ~"calc( @{sideblock_width} + 100px )";
	}
}

/* Sideblock
 *------------------------------------------------------------*/

.hygge-sideblock {
	.clearfix;
	margin-bottom: 1.7em;

	& + .hygge-sideblock-placeholder {
		display: none;
	}

	@media @desktop {
		padding: 0 30px;
		margin-bottom: 2.8em;

		&,
		& + .hygge-sideblock-placeholder {
			padding: 0;
			float: left;
			clear: left;
		}

		&.hygge-sideblock--sticked {
			position: fixed;
			top: 30px;

			body.hygge-sticky-header--true & { top: 80px; }
			body.admin-bar & { top: 62px; }
			body.hygge-sticky-header--true.admin-bar & { top: 112px; }

			& + .hygge-sideblock-placeholder {
				display: block;
			}
		}
	}

	@media @desktop-s {
		&,
		& + .hygge-sideblock-placeholder {
			width: @sideblock_width_small;
			margin-left: ~"calc( -@{sideblock_width_small} - 60px )";
		}
	}

	@media @desktop-m {
		&,
		& + .hygge-sideblock-placeholder {
			width: ~"calc( @{sideblock_width} )";
			margin-left: ~"calc( -@{sideblock_width} - 60px )";
		}
	}

	@media @desktop-l {
		&,
		& + .hygge-sideblock-placeholder {
			margin-left: ~"calc( -@{sideblock_width} - 100px )";
		}
	}

	&:empty {
		display: none;
	}
}



/* Content Width & Full Width
 *------------------------------------------------------------*/

.hygge-contentwidth,
.hygge-fullwidth {
	clear: both;
	.clearfix;

	// enable usage as first el in post that is centered
	.post__content &:not(:first-child) { margin-top: 2.8em; }
	.post__content &:not(:last-child) { margin-bottom: 2.8em; }

	& > *:last-child {
		&,
		& > .aligncenter,
		& > .alignnone {
			margin-bottom: 0;
		}
	}

	&:empty {
		display: none;
	}

	@media @tablet-h, @desktop {
		.alignleft, .alignright, .aligncenter { margin-top: 0; }
	}

	.hygge-layout-sidebar & {
		margin-left: auto !important;
		margin-right: auto !important;
		width: auto !important;
	}
}

.hygge-contentwidth {
	@media @desktop-s {
		margin-left: ~"calc( -@{sideblock_width_small} - 60px )";
	}

	@media @desktop-m {
		margin-left: ~"calc( -@{sideblock_width} - 60px )";
	}

	@media @desktop-l {
		margin-left: ~"calc( -@{sideblock_width} - 100px )";
	}

	.hygge-fullwidth & {
		margin-left: auto;
		margin-right: auto;
		max-width: 1200px;
	}
}

.hygge-fullwidth {
	width: 100%;

	.main-content &,
	.max-width-wrapper & {
		margin-left: -20px;
		width: 100vw;

		@media @tablet-v {
			margin-left: -50px;
		}
	}

	@media @tablet-h, @desktop {
		// offset to exact start of the viewport
		margin-left: ~"calc( 50% - 50vw )";

		.hygge-sidebar--true & {
			margin-left: ~"calc( 50% - 50vw + @{sidebar_width}/2 )";
		}

		.post__content & {
			width: ~"calc( 100% - 50% + 50vw - @{sideblock_width}/2 )";
			margin-left: ~"calc( 50% - 50vw - @{sideblock_width}/2 )";

			.hygge-sidebar--true & {
				width: ~"calc( 100% - 50% + 50vw + @{sidebar_width}/2 - @{sideblock_width}/2 )";
				margin-left: ~"calc( 50% - 50vw + @{sidebar_width}/2 - @{sideblock_width}/2 )";
			}
		}
	}
}

.hygge-grey-section {
	.clearfix;
	margin-top: 2.8em;
	background: @grey-pale;
	padding: 2.8em 0;

	@media @tablet-h, @desktop {
		margin-top: 4.5em;
		padding: 4.5em 0;
	}

	& + .hygge-grey-section {
		margin-top: 0;
		padding-top: 0;
	}

	.title {
		text-align: center;
		margin-bottom: 1.7em;
	}
}
